import { Bytes } from '@cmdcode/buff-utils'

export type SignOptions = Partial<SignConfig>

export interface SignConfig {
  aux       ?: Bytes
  adaptor   ?: Bytes
  nonce     ?: Bytes
  recovery  ?: Bytes
  tweak     ?: Bytes
  throws     : boolean
  xonly      : boolean
}

export interface RawOptions extends SignOptions {
  inv_tweaks   ?: boolean
  inv_nonces   ?: boolean
  key_tweaks   ?: Bytes[]
  nonce_values ?: Bytes[]
  nonce_tweaks ?: Bytes[]
}

const SIGN_DEFAULTS : SignConfig = {
  throws : false,
  xonly  : true
}

export function sign_config (
  config : SignOptions = {}
) : SignConfig {
  return { ...SIGN_DEFAULTS, ...config  }
}
